/*
The software in this package is distributed under the GNU General
Public License version 2 (with a special exception described below).

A copy of GNU General Public License (GPL) is included in this distribution,
in the file COPYING.GPL.

As a special exception, if other files instantiate templates or use macros
or inline functions from this file, or you compile this file and link it
with other works to produce a work based on this file, this file
does not by itself cause the resulting work to be covered
by the GNU General Public License.

However the source code for this file must still be made available
in accordance with section (3) of the GNU General Public License.

This exception does not invalidate any other reasons why a work based
on this file might be covered by the GNU General Public License.
*/
#include "host/pingnumber.h"

#include "boost_assert_handler.h"

//-----------------------------------------------------------------------------
// PingNumber
//-----------------------------------------------------------------------------

PingNumber::PingNumber(
        const PingNumberType number
) :
    OriginalNumber( number ),
    Number( number )
{
    BOOST_ASSERT( 0 < number );
}

PingNumber::~PingNumber()
{
}

PingNumber::operator PingNumberType() const
{
    BOOST_ASSERT( 0 < Number );

    return Number;
}

void PingNumber::back_to_original()
{
    Number = OriginalNumber;

    BOOST_ASSERT( 0 < Number );
}

void PingNumber::increase()
{
    BOOST_ASSERT( 0 < Number );

    if ( can_increase() )
    {
        Number = Number * 5;
    }

    BOOST_ASSERT( 0 < Number );
}

/** returns true if have not increased yet */
bool PingNumber::can_increase() const
{
    return Number == OriginalNumber;
}
