/*
The software in this package is distributed under the GNU General
Public License version 2 (with a special exception described below).

A copy of GNU General Public License (GPL) is included in this distribution,
in the file COPYING.GPL.

As a special exception, if other files instantiate templates or use macros
or inline functions from this file, or you compile this file and link it
with other works to produce a work based on this file, this file
does not by itself cause the resulting work to be covered
by the GNU General Public License.

However the source code for this file must still be made available
in accordance with section (3) of the GNU General Public License.

This exception does not invalidate any other reasons why a work based
on this file might be covered by the GNU General Public License.
*/

#ifndef LINK_STATUS_H
#define LINK_STATUS_H

#include <string>

#include <boost/shared_ptr.hpp>

//-----------------------------------------------------------------------------
// LinkStatus
//-----------------------------------------------------------------------------

/**
 * @brief This is a fake link status class.
 * Scope: one object for many hosts.
 */
class LinkStatus
{
public:
    LinkStatus();
    ~LinkStatus();

    void notify_host_up( const std::string &host_address );
    void notify_host_down( const std::string &host_address );

};

//-----------------------------------------------------------------------------

LinkStatus::LinkStatus()
{
}

LinkStatus::~LinkStatus()
{
}

void LinkStatus::notify_host_up( const std::string & )
{
}

void LinkStatus::notify_host_down( const std::string & )
{
}

//-----------------------------------------------------------------------------
// LinkStatusItem
//-----------------------------------------------------------------------------

typedef boost::shared_ptr<LinkStatus> LinkStatusItem;

#endif // LINK_STATUS_H
